﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
#If B4A

#Else If B4i
#DesignerProperty: Key: Orientation, DisplayName: Orientation, FieldType: String, DefaultValue: UILayoutConstraintAxisHorizontal, List: UILayoutConstraintAxisHorizontal|UILayoutConstraintAxisVertical
#DesignerProperty: Key: Alignment, DisplayName: Alignment, FieldType: String, DefaultValue: Default, List: Default|UIStackViewAlignmentCenter|UIStackViewAlignmentRight
#DesignerProperty: Key: Spacing, DisplayName: Spacing, FieldType: Int, DefaultValue: 0
#Else If B4J
#DesignerProperty: Key: Top, DisplayName: Top Padding, FieldType: Int, DefaultValue: 0
#DesignerProperty: Key: Right, DisplayName: Right Padding, FieldType: Int, DefaultValue: 0
#DesignerProperty: Key: Bottom, DisplayName: Bottom Padding, FieldType: Int, DefaultValue: 0
#DesignerProperty: Key: Left, DisplayName: Left Padding, FieldType: Int, DefaultValue: 0
#End If

Sub Class_Globals
	#If B4A
	Private mStackJO As JavaObject
	Private mBase As Panel
	#End If
	#If B4i
	Private mStackNO As NativeObject
	Private mBase As Panel
	#End If
	#If B4J
	Private mStackJO As JavaObject
	Private mBase As Pane
	#End If
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (EventName As String)
	
End Sub

#Region "Custom View Methods"
Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
	Dim Orientation As String = Props.Get("Orientation")
	Dim Alignment As String = Props.Get("Alignment")
	Log (Orientation)
	Log (Alignment)
	#If B4A
	
	#Else If B4i
	Dim Spacing As Float = Props.Get("Spacing")
	#Else If B4J
	Dim Spacing As Double = Props.Get("Spacing")
	Dim Top, Right, Bottom, Left As Double
	Top = Props.Get("Top")
	Right = Props.Get("Right")
	Bottom = Props.Get("Bottom")
	Left = Props.Get("Left")	
	#End If
	
	#If B4A
	
	#Else If B4i
	Dim SV As NativeObject
	SV = SV.Initialize("UIStackView").RunMethod("alloc", Null).RunMethod("init", Null)
	SV.SetField("axis", Orientation)
	If Alignment.ToLowerCase <> "Default" Then SV.SetField("alignment", Alignment)
	SV.SetField("spacing", Spacing)
	
	mStackNO = SV
	mBase.AddView(mStackNO, 0,0, mBase.Width, mBase.Height)
	#Else If B4J
	mStackJO.InitializeNewInstance($"javafx.scene.layout.${Orientation.CharAt(0)}Box"$, Null)
	mStackJO.RunMethod("setSpacing", Array(Spacing))
	If Alignment <> "Left" Then mStackJO.RunMethod("setAlignment", Array(Alignment.ToUpperCase))
	mStackJO.RunMethod("setPadding", Array As Object(CreateInsets(Top, Right, Bottom, Left)))
	mBase.AddNode(mStackJO, 0, 0, mBase.Width, mBase.Height)	
	#End If
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	#If B4J
	mStackJO.RunMethod("setPrefWidth", Array(Width))
	mStackJO.RunMethod("setPrefHeight", Array(Height))
	#End If
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

'Returns the StackView.
Public Sub GetStackView As View
	Return mStackNO
End Sub
#End Region

#Region "Main Methods"
#If B4A 

#Else If B4i
'Add a view to the StackView
Public Sub AddView (TheView As View)
	Dim VNO As NativeObject = TheView
	VNO.GetField("heightAnchor").RunMethodWithBlocks("constraintEqualToConstant:", Array(TheView.Height))
	VNO.GetField("widthAnchor").RunMethodWithBlocks("constraintEqualToConstant:", Array(TheView.Width))
		
	mStackNO.RunMethodWithBlocks("addArrangedSubview:", Array(TheView))
End Sub

'Adds an array of views to the StackView
Public Sub AddViewArray (Views As List)
	For i = 0 To Views.Size - 1
		AddView(Views.Get(i))
	Next
End Sub

Public Sub Render 
	mBase.AddView(mStackNO, 0,0, mBase.Width, mBase.Height)
End Sub
#Else If B4J and UI
'Add a Node to the StackView
Public Sub AddNode (TheNode As Node)
	mStackJO.RunMethodJO("getChildren", Null).RunMethod("add", Array As Object(TheNode))
End Sub

'Adds an array of nodes to the StackView. 
'If using "Array As" to create the list then type must be "Object".
Public Sub AddNodeArray (Controls As List)
	For i = 0 To Controls.Size - 1
		AddNode(Controls.Get(i))
	Next
End Sub

Private Sub CreateInsets (T As Double, R As Double, B As Double, L As Double As JavaObject
	Dim Insets As JavaObject
	Insets.InitializeNewInstance("javafx.geometry.Insets", Array As Object(T, R, B, L))
	Return InsetsJo
End Sub
#End If
#End Region